main_instance <- null;

import("pathfinder.road", "RoadPathFinder", 4);

class TestAI extends AIController
{
  MT = {routes = []};
  
  constructor()
  {

  }
}

function TestAI::Start()
{
  AICompany.SetName("TestAI");
    
  local route = {src = AIMap.GetTileIndex(20,20),dst = AIMap.GetTileIndex(80,20), source = AIMap.GetTileIndex(20,20), destination = AIMap.GetTileIndex(80,20), cargo = 0} 
        
  build_station(route, true);
  build_station(route, false);
  
  road_connect(route)
}

function road_connect(route)
{
  local pathfinder = RoadPathFinder();
  AIRoad.SetCurrentRoadType(AIRoad.ROADTYPE_ROAD);
  Sleep(1);
  //pathfinder.cost.turn = 5000;
  //pathfinder.cost.slope  = 5000;
  pathfinder.cost.bridge_per_tile = 300;
  pathfinder.cost.no_existing_road = 60;
  pathfinder.cost.max_bridge_length = 25;
  pathfinder.cost.max_tunnel_length = 25;
  
  pathfinder.cost.estimate_multiplier = 5;
  
  
  AISign.BuildSign(route.src_road,"src");
  AISign.BuildSign(route.dst_road,"dst");
    
  pathfinder.InitializePath([route.src_road], [route.dst_road]);

  local path = false;
  local error = AIError.ERR_NONE;
  
  while (path == false)
  {
    AILog.Info("Search ..."+GetTick());
    path = pathfinder.FindPath(500);
    Sleep(1);
  }
  
  while (path == null)
  {
    AILog.Info("Null");
  }
  while (path == 0)
  {
    AILog.Info("0");
  }
    
  
  local ok = true;
  while (path != null) 
  {
    AILog.Info("Build ...");
    local par = path.GetParent();
    if (par != null) 
    {
      local last_node = path.GetTile();
      if (AIMap.DistanceManhattan(path.GetTile(), par.GetTile()) == 1 ) 
      {
        AISign.BuildSign(par.GetTile(),"R");
        do
        {
          if (!AIRoad.BuildRoad(path.GetTile(), par.GetTile())) 
          {
            error = AIError.GetLastError()
          }
        }
        while (error == AIError.ERR_VEHICLE_IN_THE_WAY)
        if (AIError.GetLastError()!=AIError.ERR_NONE && AIError.GetLastError()!=AIError.ERR_ALREADY_BUILT) 
        {
          ok=false;
          AISign.BuildSign(par.GetTile(),"A"+AIError.GetLastError());
          AILog.Info(" "+AIError.GetLastErrorString());
        }
      } 
      else 
      {
        if (!AIBridge.IsBridgeTile(path.GetTile()) && !AITunnel.IsTunnelTile(path.GetTile())) 
        {
          AILog.Info("Bridge/Tunel ...");
          if (AIRoad.IsRoadTile(path.GetTile())) AITile.DemolishTile(path.GetTile());
          AISign.BuildSign(par.GetTile(),"TR");
          if (AITunnel.GetOtherTunnelEnd(path.GetTile()) == par.GetTile()) 
          {
            AILog.Info("Tunel");//AIVehicle.VEHICLE_ROAD
            if (!AITunnel.BuildTunnel(AIVehicle.VT_ROAD, path.GetTile())) 
            {
              AILog.Info("error ...");
              AISign.BuildSign(par.GetTile(),"B"+AIError.GetLastError());
              if (AIError.GetLastError()!=AIError.ERR_NONE && AIError.GetLastError()!=AIError.ERR_ALREADY_BUILT) {ok=false;}
            }
          }
         
          else 
          {
            local bridge_list = AIBridgeList_Length(AIMap.DistanceManhattan(path.GetTile(), par.GetTile()) + 1);
            bridge_list.Valuate(AIBridge.GetMaxSpeed);
            bridge_list.Sort(AIAbstractList.SORT_BY_VALUE, false);
            AILog.Info("Bridge");
            AISign.BuildSign(par.GetTile(),"BR");
            if (!AIBridge.BuildBridge(AIVehicle.VT_ROAD, bridge_list.Begin(), path.GetTile(), par.GetTile())) 
            {
              AILog.Info("error ...");
              AISign.BuildSign(par.GetTile(),"C"+AIError.GetLastError());
              if (AIError.GetLastError()!=AIError.ERR_NONE && AIError.GetLastError()!=AIError.ERR_ALREADY_BUILT) {ok=false;}
            }
          }
        }
      }
    }
    path = par;
  }
  if (!ok) {road_connect(route); AILog.Info("Neco se nepovedlo, hledam znovu");};  
  return AIError.ERR_NONE;
}  

function build_station(route, source)
{
  local lloc;
  local ok=true;
  local error = null;
  
  AIRoad.SetCurrentRoadType(AIRoad.ROADTYPE_ROAD);
  
  //for(local x=-7; x<15; x++)
  {
    //for(local y=-7; y<15; y++)
    {
      ok = true;
      
      if (source)
      {
        lloc = route.src;
        //lloc = AIIndustry.GetLocation(route.source) + AIMap.GetTileIndex(x,y);
        //if (AITile.GetCargoProduction(lloc,route.cargo,1,1,AIStation.GetCoverageRadius(AIStation.STATION_TRUCK_STOP))==0)
        { 
          //ok=false;
          //continue;
        };
          
      }
      else
      {
        lloc = route.dst;
        //lloc = AIIndustry.GetLocation(route.destination) + AIMap.GetTileIndex(x,y);
        //if (AITile.GetCargoAcceptance(lloc,route.cargo,1,1,AIStation.GetCoverageRadius(AIStation.STATION_TRUCK_STOP))==0) 
        { 
          //ok=false;
          //continue;
        };       
      } 
      {

        AILog.Info("Stanice "+ok);
        error=AIError.ERR_NONE;
        AIRoad.BuildRoad(lloc+AIMap.GetTileIndex(0,-1),lloc+AIMap.GetTileIndex(0,1));
        if (AIError.GetLastError()!=AIError.ERR_NONE) {ok=false;error=AIError.GetLastError();} 
        AILog.Info(AIError.GetLastErrorString());  
        AIRoad.BuildRoad(lloc+AIMap.GetTileIndex(1,-1),lloc+AIMap.GetTileIndex(1,1));
        if (AIError.GetLastError()!=AIError.ERR_NONE) {ok=false;error=AIError.GetLastError();}
        AIRoad.BuildRoad(lloc+AIMap.GetTileIndex(-1,-1),lloc+AIMap.GetTileIndex(-1,1));
        if (AIError.GetLastError()!=AIError.ERR_NONE) {ok=false;error=AIError.GetLastError(); }     
        AIRoad.BuildRoad(lloc+AIMap.GetTileIndex(1,-1),lloc+AIMap.GetTileIndex(-1,-1));
        if (AIError.GetLastError()!=AIError.ERR_NONE) {ok=false;error=AIError.GetLastError();}
        AIRoad.BuildRoad(lloc+AIMap.GetTileIndex(1,1),lloc+AIMap.GetTileIndex(-1,1));
        if (AIError.GetLastError()!=AIError.ERR_NONE) {ok=false;error=AIError.GetLastError();}          
        AILog.Info("Stanice "+ok);
          
        AIRoad.BuildDriveThroughRoadStation(lloc,lloc+AIMap.GetTileIndex(0,1),AIRoad.ROADVEHTYPE_TRUCK,AIStation.STATION_NEW);
        if (AIError.GetLastError()!=AIError.ERR_NONE) {ok=false;error=AIError.GetLastError();}                
        AIRoad.BuildDriveThroughRoadStation(lloc+AIMap.GetTileIndex(1,0),lloc+AIMap.GetTileIndex(1,1),AIRoad.ROADVEHTYPE_TRUCK,AIStation.STATION_JOIN_ADJACENT);
        if (AIError.GetLastError()!=AIError.ERR_NONE) {ok=false;error=AIError.GetLastError();}
        AILog.Info("Stanice "+ok);

        AITile.DemolishTile(lloc + AIMap.GetTileIndex(-2,0));
        if (AIError.GetLastError()!=AIError.ERR_NONE) {ok=false;error=AIError.GetLastError();}        
        AIRoad.BuildRoad(lloc + AIMap.GetTileIndex(-2,0),lloc + AIMap.GetTileIndex(-1,0));
        if (AIError.GetLastError()!=AIError.ERR_NONE) {ok=false;error=AIError.GetLastError();}      
        AITile.DemolishTile(lloc + AIMap.GetTileIndex(-2,0));
        if (AIError.GetLastError()!=AIError.ERR_NONE) {ok=false;error=AIError.GetLastError();}
        AIRoad.BuildRoadDepot(lloc + AIMap.GetTileIndex(-2,0),lloc + AIMap.GetTileIndex(-1,0));
        if (AIError.GetLastError()!=AIError.ERR_NONE) {ok=false;error=AIError.GetLastError();}
        AILog.Info("Stanice "+ok);
             
      }
    }
  }
               
  if (source)
  {
    route.src_station <- lloc;
    route.src_depot <- lloc + AIMap.GetTileIndex(-2,0);
    route.src_road <- lloc + AIMap.GetTileIndex(0,0);
  }
  else
  {
    route.dst_station <- lloc;
    route.dst_depot <- lloc + AIMap.GetTileIndex(-2,0);
    route.dst_road <- lloc + AIMap.GetTileIndex(0,0); 
  }
  
  if (error!=AIError.ERR_NONE) 
  {
    AILog.Info("Stanice se nepovedla, prumysl pridan na blacklist")
    AILog.Info("Blacklisting: "+AIIndustry.GetName(source?route.source:route.destination))
  }
    
  return error;
}


